#!/system/bin/sh 
# --------------------------------------------------------------------
# (C) Copyright 2014 Gigaset Communications GmbH PD DEV HED (JR)
# Joerg Rensing
# $Id: $
#
# $Revision: $
#
# --------------------------------------------------------------------
# Setup ZRam-swap and KSM for JB
# --------------------------------------------------------------------
#
# --------------------------------------------------------------------

# update/create node(s)
busybox mdev -s



# -----------------------------------------------------
# Enable ZRam-swap; but configure only if device exists
# -----------------------------------------------------
if [ -e /dev/zram0 ] ; then
	# 	## create 64MB zRam device
	# 	#echo 67108864 > /sys/block/zram0/disksize
	# 	# create 80MB zRam device
	# 	echo 83886080 > /sys/block/zram0/disksize
	# 	## create 96MB zRam device
	# 	#echo 100663296 > /sys/block/zram0/disksize
	# 	## create 112MB zRam device
	# 	#echo 117440512 > /sys/block/zram0/disksize
	# 	## create 128MB zRam device
	# 	#echo 134217728 > /sys/block/zram0/disksize

	# --------------------------------------------------
	# dyn. calculation of used swap size dep. on memsize
	# useful for 512MB/1GB devices
	memsize=`cat /proc/meminfo | grep MemTotal | busybox awk '{print $2}'`
	# Memtotal is value is KB
	calced_swap_kb=$(($memsize / 5))
	calced_swap=$(($calced_swap_kb * 1024))
	echo "calced_swap: $calced_swap"

	echo $calced_swap > /sys/block/zram0/disksize

	# Creating swap filesystems
	busybox mkswap /dev/zram0

	# Switch the swaps on
	busybox swapon /dev/zram0

	# finally enables the swaping
	# Swappiness can have a value between 0 and 100, the default value is 60.
	# Setting this parameter to a low value will reduce swapping from RAM,
	# and is known to improve responsiveness on many systems. 
	echo 100 > /proc/sys/vm/swappiness
	#echo  30 > /proc/sys/vm/swappiness

	echo "ZRam-swap activated..."

else
	echo "No zram device found..."
	# exit 1
fi

# ------------------------------------------------
# Enable KSM; but configure only if device exists
# ------------------------------------------------
if [ -e /sys/kernel/mm/ksm/run ] ; then
	echo 100 > /sys/kernel/mm/ksm/pages_to_scan
	echo 500 > /sys/kernel/mm/ksm/sleep_millisecs
	echo 1 > //sys/kernel/mm/ksm/run
	echo "KSM activated..."
else
	echo "No KSM enabled kernel found..."
	# exit 1
fi

# EOF
